#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  Gray
#property indicator_color2  LimeGreen
#property indicator_color3  Red
#property indicator_color4  Silver
#property indicator_width1  2
#property indicator_style2  STYLE_DOT
#property indicator_style3  STYLE_DOT

extern int    RsiPeriod = 50;
extern int    RsiPrice  = PRICE_CLOSE;
extern double EmaPeriod = 10;

double work[];
double avg[];
double emaUp[];
double emaDn[];


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,work);
   SetIndexBuffer(1,emaUp);
   SetIndexBuffer(2,emaDn);
   SetIndexBuffer(3,avg);
   return(0);
}
int start()
{
   int i,countedBars = IndicatorCounted();
      if (countedBars<0) return(-1);
      if (countedBars>0) countedBars--;
         int limit = MathMin(Bars-countedBars,Bars-1);

   //
   //
   //
   //
   //
   
   double alpha = 2.0/(1.0+EmaPeriod);
   for(i=limit; i>=0; i--)
   {
      work[i] = iRSI(NULL,0,RsiPeriod,RsiPrice,i);
         int y = iBarShift(NULL,PERIOD_D1,Time[i]);
         int x = iBarShift(NULL,PERIOD_D1,Time[i-1]);
         if (x!=y)
         {
            int    k       = iBarShift(NULL,0,iTime(NULL,PERIOD_D1,y));
            double average = work[k];
            int    c       = 1;
               for (int j=k-1; j>=i; j--,c++) average += work[j]; average /= c;
               for (    j=k  ; j>=i; j--)
               {
                  avg[j] = average;
                  if (j==k)
                  {
                     emaUp[j] = average;
                     emaDn[j] = average;
                  }
                  else
                  {
                     emaUp[j]=emaUp[j+1];
                     emaDn[j]=emaDn[j+1];
                        if (emaUp[j]<avg[j]) emaUp[j] = avg[j];
                        if (emaDn[j]>avg[j]) emaDn[j] = avg[j];
                        if (work[j]>avg[j])  emaUp[j] = emaUp[j+1]+alpha*(work[j]-emaUp[j+1]);
                        if (work[j]<avg[j])  emaDn[j] = emaDn[j+1]+alpha*(work[j]-emaDn[j+1]);
                  }                     
               }                        
         }
   }
   return(0);
}